(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react'), require('dva')) :
	typeof define === 'function' && define.amd ? define(['react', 'dva'], factory) :
	(global.g_umiUIPlugins = global.g_umiUIPlugins || {}, global.g_umiUIPlugins.routes = factory(global.React,global.dva));
}(this, (function (react,dva) { 'use strict';

	react = react && react.hasOwnProperty('default') ? react['default'] : react;
	dva = dva && dva.hasOwnProperty('default') ? dva['default'] : dva;

	function unwrapExports (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
	}

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var model = createCommonjsModule(function (module, exports) {

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = void 0;

	function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

	var _default = {
	  namespace: 'routes',
	  state: {
	    data: []
	  },
	  subscriptions: {
	    setup({
	      history,
	      dispatch
	    }) {
	      return history.listen(({
	        pathname
	      }) => {
	        if (pathname === '/routes') {
	          setTimeout(() => {
	            window.send('routes/fetch');
	          }, 1000);
	        }
	      });
	    }

	  },
	  reducers: {
	    save(state, {
	      payload
	    }) {
	      return _objectSpread({}, state, {
	        data: payload
	      });
	    }

	  }
	};
	exports.default = _default;
	});

	unwrapExports(model);

	var client = createCommonjsModule(function (module, exports) {

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = void 0;

	var _react = _interopRequireDefault(react);



	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var Routes = (0, dva.connect)(function (state) {
	  return {
	    routes: state.routes
	  };
	})(function (props) {
	  function renderRoutes(routes) {
	    return _react.default.createElement("ul", null, routes.map(function (route, i) {
	      if (!route.path) return null;
	      return _react.default.createElement("li", {
	        key: route.key || i
	      }, _react.default.createElement("div", null, route.path, _react.default.createElement("button", {
	        onClick: function (route) {
	          window.send('rm', ['page', route.component]);
	        }.bind(null, route)
	      }, "delete"), _react.default.createElement("button", null, "move")), route.routes ? renderRoutes(route.routes) : null);
	    }));
	  }

	  return _react.default.createElement("div", null, _react.default.createElement("h3", null, "routes page"), _react.default.createElement("button", {
	    onClick: function onClick() {
	      var name = window.prompt("What's your page name?");
	      window.send('generate', ['page', name]);
	    }
	  }, "add route"), renderRoutes(props.routes.data));
	});

	var _default = function _default(api) {
	  api.addPanel({
	    title: 'Routes Manager',
	    path: '/routes',
	    component: Routes,
	    models: [model.default]
	  });
	};

	exports.default = _default;
	});

	var client$1 = unwrapExports(client);

	return client$1;

})));
